# MegaLettering translated comics PHP engine Copyright (c) 2001 Lapo Luchini <lapo@lapo.it>
# $Header: /cvs/MTi/MTi.sql,v 1.13 2003/10/30 08:52:31 lapo Exp $

# This file is part of MegaLettering.
#
# MegaLettering is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# MegaLettering is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with MegaLettering; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

# phpMyAdmin MySQL-Dump
# version 2.5.1
# http://www.phpmyadmin.net/ (download page)
#
# Host: localhost
# Generato il: 14 Ott, 2003 at 03:23 AM
# Versione MySQL: 3.23.36
# Versione PHP: 4.3.2
# Database : `MTi`
# --------------------------------------------------------

#
# Struttura della tabella `MTi_Baloons`
#
# Creazione: 14 Ott, 2003 at 02:28 AM
# Ultimo cambiamento: 14 Ott, 2003 at 02:28 AM
# Ultimo controllo: 14 Ott, 2003 at 02:28 AM
#

DROP TABLE IF EXISTS `MTi_Baloons`;
CREATE TABLE `MTi_Baloons` (
  `IDBaloon` int(11) NOT NULL auto_increment,
  `IDStrip` smallint(6) NOT NULL default '0',
  `Shape` varchar(255) NOT NULL default '',
  `IDCharacter` int(11) default NULL,
  PRIMARY KEY  (`IDBaloon`),
  KEY `IDStrip` (`IDStrip`)
) TYPE=MyISAM COMMENT='Baloons shape';
# --------------------------------------------------------

#
# Struttura della tabella `MTi_Characters`
#
# Creazione: 30 Set, 2003 at 10:45 AM
# Ultimo cambiamento: 09 Ott, 2003 at 01:23 AM
# Ultimo controllo: 30 Set, 2003 at 10:45 AM
#

DROP TABLE IF EXISTS `MTi_Characters`;
CREATE TABLE `MTi_Characters` (
  `IDCharacter` smallint(6) NOT NULL auto_increment,
  `Name` varchar(50) NOT NULL default '',
  PRIMARY KEY  (`IDCharacter`),
  KEY `Nome` (`Name`)
) TYPE=MyISAM COMMENT='Character names';
# --------------------------------------------------------

#
# Struttura della tabella `MTi_Console`
#
# Creazione: 14 Ott, 2003 at 03:10 AM
# Ultimo cambiamento: 14 Ott, 2003 at 03:10 AM
# Ultimo controllo: 14 Ott, 2003 at 03:10 AM
#

DROP TABLE IF EXISTS `MTi_Console`;
CREATE TABLE `MTi_Console` (
  `IDConsole` int(11) NOT NULL auto_increment,
  `Username` varchar(15) NOT NULL default '',
  `IDLanguage` char(2) NOT NULL default '',
  `IDStrip` smallint(6) NOT NULL default '0',
  `Posizione` enum('sinistra','destra') NOT NULL default 'sinistra',
  `Immagine` varchar(50) NOT NULL default '',
  `ImmagineLink` varchar(255) NOT NULL default '',
  `ImmagineAlt` varchar(50) NOT NULL default '',
  `Titolo` tinytext NOT NULL,
  `Testo` text NOT NULL,
  PRIMARY KEY  (`IDConsole`),
  KEY `Rant` (`IDLanguage`,`Posizione`,`IDStrip`)
) TYPE=MyISAM COMMENT='Console rants (language dependant)';
# --------------------------------------------------------

#
# Struttura della tabella `MTi_Languages`
#
# Creazione: 30 Set, 2003 at 12:44 AM
# Ultimo cambiamento: 30 Set, 2003 at 12:44 AM
#

DROP TABLE IF EXISTS `MTi_Languages`;
CREATE TABLE `MTi_Languages` (
  `IDLanguage` char(2) NOT NULL default '',
  `Nome` varchar(50) NOT NULL default '',
  `Codice` varchar(20) NOT NULL default '',
  `URL` tinytext NOT NULL,
  PRIMARY KEY  (`IDLanguage`)
) TYPE=MyISAM COMMENT='Available languages';
# --------------------------------------------------------

#
# Struttura della tabella `MTi_Links`
#
# Creazione: 30 Set, 2003 at 12:45 AM
# Ultimo cambiamento: 07 Ott, 2003 at 02:56 PM
# Ultimo controllo: 30 Set, 2003 at 12:45 AM
#

DROP TABLE IF EXISTS `MTi_Links`;
CREATE TABLE `MTi_Links` (
  `IDLink` int(11) NOT NULL auto_increment,
  `IDLanguage` char(2) NOT NULL default '',
  `Pubblicazione` date NOT NULL default '0000-00-00',
  `URL` tinytext NOT NULL,
  `Titolo` varchar(50) NOT NULL default '',
  `Tipo` varchar(25) NOT NULL default '',
  `Testo` text NOT NULL,
  PRIMARY KEY  (`IDLink`,`IDLink`),
  KEY `Data` (`Pubblicazione`)
) TYPE=MyISAM COMMENT='Link to related/interesting websites';
# --------------------------------------------------------

#
# Struttura della tabella `MTi_Staff`
#
# Creazione: 30 Set, 2003 at 12:45 AM
# Ultimo cambiamento: 03 Ott, 2003 at 08:14 PM
# Ultimo controllo: 30 Set, 2003 at 12:45 AM
#

DROP TABLE IF EXISTS `MTi_Staff`;
CREATE TABLE `MTi_Staff` (
  `Username` varchar(15) NOT NULL default '',
  `Nome` varchar(30) NOT NULL default '',
  `IDLanguage` char(2) NOT NULL default '',
  `email` varchar(30) NOT NULL default '',
  `Ruolo` varchar(30) NOT NULL default '',
  PRIMARY KEY  (`Username`),
  KEY `IDLingua` (`IDLanguage`)
) TYPE=MyISAM COMMENT='Staff & roles (language dependant)';
# --------------------------------------------------------

#
# Struttura della tabella `MTi_Strips`
#
# Creazione: 30 Set, 2003 at 12:48 AM
# Ultimo cambiamento: 14 Ott, 2003 at 02:05 AM
#

DROP TABLE IF EXISTS `MTi_Strips`;
CREATE TABLE `MTi_Strips` (
  `IDStrip` smallint(6) NOT NULL default '0',
  `URL` tinytext NOT NULL,
  `DimX` smallint(6) NOT NULL default '0',
  `DimY` smallint(6) NOT NULL default '0',
  PRIMARY KEY  (`IDStrip`)
) TYPE=MyISAM COMMENT='Strip data';
# --------------------------------------------------------

#
# Struttura della tabella `MTi_Styles`
#
# Creazione: 29 Set, 2003 at 04:04 PM
# Ultimo cambiamento: 13 Ott, 2003 at 05:52 PM
#

DROP TABLE IF EXISTS `MTi_Styles`;
CREATE TABLE `MTi_Styles` (
  `Stile` varchar(25) NOT NULL default '',
  `Font` varchar(50) NOT NULL default '',
  `Dimensione` float(5,2) NOT NULL default '0.00',
  PRIMARY KEY  (`Stile`)
) TYPE=MyISAM COMMENT='Text styles';
# --------------------------------------------------------

#
# Struttura della tabella `MTi_Texts`
#
# Creazione: 14 Ott, 2003 at 02:27 AM
# Ultimo cambiamento: 14 Ott, 2003 at 02:27 AM
#

DROP TABLE IF EXISTS `MTi_Texts`;
CREATE TABLE `MTi_Texts` (
  `IDText` int(11) NOT NULL auto_increment,
  `IDLanguage` char(2) NOT NULL default '',
  `IDBaloon` int(11) NOT NULL default '0',
  `CenterX` smallint(6) NOT NULL default '0',
  `CenterY` smallint(6) NOT NULL default '0',
  `Testo` text NOT NULL,
  PRIMARY KEY  (`IDText`),
  UNIQUE KEY `Text` (`IDLanguage`,`IDBaloon`)
) TYPE=MyISAM COMMENT='Baloon texts (language dependant)';
# --------------------------------------------------------

#
# Struttura della tabella `MTi_Titles`
#
# Creazione: 14 Ott, 2003 at 02:01 AM
# Ultimo cambiamento: 14 Ott, 2003 at 02:01 AM
# Ultimo controllo: 14 Ott, 2003 at 02:01 AM
#

DROP TABLE IF EXISTS `MTi_Titles`;
CREATE TABLE `MTi_Titles` (
  `IDTitle` int(11) NOT NULL auto_increment,
  `IDLanguage` char(2) NOT NULL default '',
  `IDStrip` int(11) NOT NULL default '0',
  `Testo` tinytext NOT NULL,
  `Pubblicazione` date NOT NULL default '0000-00-00',
  `Versione` datetime NOT NULL default '0000-00-00 00:00:00',
  `Discussione` tinytext NOT NULL,
  PRIMARY KEY  (`IDTitle`),
  UNIQUE KEY `Title` (`IDLanguage`,`IDStrip`),
  KEY `Publishing` (`Pubblicazione`)
) TYPE=MyISAM COMMENT='Strip titles and publish date (language dependant)';
# --------------------------------------------------------

#
# Struttura della tabella `PMA_bookmark`
#
# Creazione: 01 Ago, 2003 at 07:11 PM
# Ultimo cambiamento: 01 Ago, 2003 at 07:11 PM
#

DROP TABLE IF EXISTS `PMA_bookmark`;
CREATE TABLE `PMA_bookmark` (
  `id` int(11) NOT NULL auto_increment,
  `dbase` varchar(255) NOT NULL default '',
  `user` varchar(255) NOT NULL default '',
  `label` varchar(255) NOT NULL default '',
  `query` text NOT NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM COMMENT='Bookmarks';
# --------------------------------------------------------

#
# Struttura della tabella `PMA_column_info`
#
# Creazione: 01 Ago, 2003 at 07:11 PM
# Ultimo cambiamento: 01 Ago, 2003 at 07:11 PM
#

DROP TABLE IF EXISTS `PMA_column_info`;
CREATE TABLE `PMA_column_info` (
  `id` int(5) unsigned NOT NULL auto_increment,
  `db_name` varchar(64) NOT NULL default '',
  `table_name` varchar(64) NOT NULL default '',
  `column_name` varchar(64) NOT NULL default '',
  `comment` varchar(255) NOT NULL default '',
  `mimetype` varchar(255) NOT NULL default '',
  `transformation` varchar(255) NOT NULL default '',
  `transformation_options` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `db_name` (`db_name`,`table_name`,`column_name`)
) TYPE=MyISAM COMMENT='Column Information for phpMyAdmin';
# --------------------------------------------------------

#
# Struttura della tabella `PMA_history`
#
# Creazione: 01 Ago, 2003 at 07:11 PM
# Ultimo cambiamento: 01 Ago, 2003 at 07:11 PM
#

DROP TABLE IF EXISTS `PMA_history`;
CREATE TABLE `PMA_history` (
  `id` bigint(20) unsigned NOT NULL auto_increment,
  `username` varchar(64) NOT NULL default '',
  `db` varchar(64) NOT NULL default '',
  `table` varchar(64) NOT NULL default '',
  `timevalue` timestamp(14) NOT NULL,
  `sqlquery` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `username` (`username`,`db`,`table`,`timevalue`)
) TYPE=MyISAM COMMENT='SQL history';
# --------------------------------------------------------

#
# Struttura della tabella `PMA_pdf_pages`
#
# Creazione: 01 Ago, 2003 at 07:11 PM
# Ultimo cambiamento: 01 Ago, 2003 at 07:11 PM
#

DROP TABLE IF EXISTS `PMA_pdf_pages`;
CREATE TABLE `PMA_pdf_pages` (
  `db_name` varchar(64) NOT NULL default '',
  `page_nr` int(10) unsigned NOT NULL auto_increment,
  `page_descr` varchar(50) NOT NULL default '',
  PRIMARY KEY  (`page_nr`),
  KEY `db_name` (`db_name`)
) TYPE=MyISAM COMMENT='PDF Relationpages for PMA';
# --------------------------------------------------------

#
# Struttura della tabella `PMA_relation`
#
# Creazione: 01 Ago, 2003 at 07:11 PM
# Ultimo cambiamento: 30 Set, 2003 at 10:45 AM
#

DROP TABLE IF EXISTS `PMA_relation`;
CREATE TABLE `PMA_relation` (
  `master_db` varchar(64) NOT NULL default '',
  `master_table` varchar(64) NOT NULL default '',
  `master_field` varchar(64) NOT NULL default '',
  `foreign_db` varchar(64) NOT NULL default '',
  `foreign_table` varchar(64) NOT NULL default '',
  `foreign_field` varchar(64) NOT NULL default '',
  PRIMARY KEY  (`master_db`,`master_table`,`master_field`),
  KEY `foreign_field` (`foreign_db`,`foreign_table`)
) TYPE=MyISAM COMMENT='Relation table';
# --------------------------------------------------------

#
# Struttura della tabella `PMA_table_coords`
#
# Creazione: 01 Ago, 2003 at 07:11 PM
# Ultimo cambiamento: 01 Ago, 2003 at 07:11 PM
#

DROP TABLE IF EXISTS `PMA_table_coords`;
CREATE TABLE `PMA_table_coords` (
  `db_name` varchar(64) NOT NULL default '',
  `table_name` varchar(64) NOT NULL default '',
  `pdf_page_number` int(11) NOT NULL default '0',
  `x` float unsigned NOT NULL default '0',
  `y` float unsigned NOT NULL default '0',
  PRIMARY KEY  (`db_name`,`table_name`,`pdf_page_number`)
) TYPE=MyISAM COMMENT='Table coordinates for phpMyAdmin PDF output';
# --------------------------------------------------------

#
# Struttura della tabella `PMA_table_info`
#
# Creazione: 01 Ago, 2003 at 07:11 PM
# Ultimo cambiamento: 01 Ago, 2003 at 07:11 PM
#

DROP TABLE IF EXISTS `PMA_table_info`;
CREATE TABLE `PMA_table_info` (
  `db_name` varchar(64) NOT NULL default '',
  `table_name` varchar(64) NOT NULL default '',
  `display_field` varchar(64) NOT NULL default '',
  PRIMARY KEY  (`db_name`,`table_name`)
) TYPE=MyISAM COMMENT='Table information for phpMyAdmin';

