<?
// MegaLettering translated comics PHP engine Copyright (c) 2003 Lapo Luchini <lapo@lapo.it>
// $Header: /cvs/MTi/image.php,v 1.27 2003/10/17 11:34:08 lapo Exp $

// This file is part of MegaLettering.
//
// MegaLettering is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// MegaLettering is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with MegaLettering; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

require_once("db.php");
$style_default = 'normal';
$align_default = 'center';
$style_cache = array();

function GetStyle($s) {
    global $dbprefix, $style_cache;
    $style = &$style_cache[$s];
    if(isset($style))
	return $style;
    if(!$q = @mysql_query("SELECT Font, Dimensione FROM ${dbprefix}_Styles WHERE Stile = '" . mysql_real_escape_string($s) . '\'')) return FALSE;
    if($row = @mysql_fetch_row($q)){
	$style = array();
	$style['font'] = 'font/' . $row[0];
	$style['size'] = $row[1];
	$style_cache[$s] = $style;
    } else
	$style = FALSE;
    @mysql_free_result($q);
    return $style;
}

function MyImageTTFBBox_Piece($style, $piece) {
    $style = GetStyle($style);
    $bb = @ImageTTFBBox($style['size'], 0, $style['font'], $piece);
    $u = array();
    $u['top'] = $bb[5];
    $u['bottom'] = $bb[1];
    $u['left'] = $bb[0];
    $u['right'] = $bb[2];
    $u['width'] = $bb[2] - $bb[0];
    $u['height'] = $bb[1] - $bb[5];
    return $u;
}

function MyImageTTFBBox($sline) {
    global $debug;
    $u = array();
    $u['top'] = 0;
    $u['bottom'] = 1;
    $u['left'] = 0;
    $u['right'] = 0;
    $u['width'] = 0;
    $first = TRUE;
    foreach($sline as $line) {
	//if($debug) echo "Linea $l\n";
	//if($debug) print_r($line['bbox']);
	$u['width'] += $line['bbox']['width'];
	if($first) {
	    $u['top'] = $line['bbox']['top'];
	    if($line['bbox']['bottom'] > $u['bottom'])
		$u['bottom'] = $line['bbox']['bottom'];
	    $u['left'] = $line['bbox']['left'];
	    $u['right'] = $line['bbox']['right'];
	    $first = FALSE;
	} else {
	    if($line['bbox']['top'] < $u['top'])
		$u['top'] = $line['bbox']['top'];
	    if($line['bbox']['bottom'] > $u['bottom'])
		$u['bottom'] = $line['bbox']['bottom'];
	}
    }
    $u['height'] = $u['bottom'] - $u['top'];
    $u['right'] = $u['left'] + $u['width'];
    //if($debug) print_r($u);
    return $u;
}

function StyleSplit($line, &$style, &$align) {
    $u = array();
    if(substr($line, 0, 8) == '$<align_') {
	switch(substr($line, 8, 1)) {
	case 'l':
	    $align = 'left';
	    break;
	case 'c':
	    $align = 'center';
	    break;
	case 'r':
	    $align = 'right';
	    break;
	}
	$line = substr($line, 10);
    }
    if(!preg_match_all('/\$<([a-z_]+)(>)/', $line, $match, PREG_SET_ORDER | PREG_OFFSET_CAPTURE)) { // warning: PREG_OFFSET_CAPTURE requires php 4.3.0+
	$u[0] = array();
	$u[0]['style'] = $style;
	$u[0]['text'] = $line;
	$u[0]['bbox'] = MyImageTTFBBox_Piece($u[0]['style'], $u[0]['text']);
    } else {
	$last_idx = 0;
	$last_off = 0;
	foreach($match as $m) {
	    // $m[0] is the full match
	    // $m[1] is the first expression
	    // $m[x][0] is the string
	    // $m[x][1] is the offset
	    if($m[1][1] - 2 - $last_off > 0) {
		if(($last_idx >= 2) && ($style == $u[$last_idx - 2])) {
		    $u[$last_idx - 1]['text'] .= substr($line, $last_off, $m[1][1] - 2 - $last_off);
		} else {
		    $u[$last_idx] = array();
		    $u[$last_idx]['style'] = $style;
		    $u[$last_idx]['text'] = substr($line, $last_off, $m[1][1] - 2 - $last_off);
		    $u[$last_idx]['bbox'] = MyImageTTFBBox_Piece($u[$last_idx]['style'], $u[$last_idx]['text']);
		    $last_idx++;
		}
	    }
	    $style = $m[1][0];
	    $last_off = $m[2][1] + 1;
	}
	if($last_off < strlen($line)) {
	    if(($last_idx >= 2) && ($style == $u[$last_idx - 2])) {
		$u[$last_idx - 1]['text'] .= substr($line, $last_off);
	    } else {
		$u[$last_idx]['style'] = $style;
		$u[$last_idx]['text'] = substr($line, $last_off);
		$u[$last_idx]['bbox'] = MyImageTTFBBox_Piece($u[$last_idx]['style'], $u[$last_idx]['text']);
		$last_idx++;
	    }
	}
    }
    return $u;
}

function ImageCreateFromFile($s) {
    if(!@preg_match('/\.(gif|jpe?g|png)$/i', strtolower($s), $m)) return FALSE;
    if($m[1] == 'gif')
	return ImageCreateFromGIF($s);
    elseif($m[1] == 'png')
	return ImageCreateFromPNG($s);
    else
	return ImageCreateFromJPEG($s);
}

function SubtitleStrip($id, $lang, $dest) {
    global $dbprefix, $style_default, $align_default, $debug;

    $strip = GetStrip($id);
    if(!$img = @ImageCreateFromFile($strip['filename'])) return FALSE;
    
    // let's try to upgade the number of colours
    /*for($i = 0; $i < 256; $i++)
	ImageColorAllocate($img, $i, $i, $i);*/

    // finds the colors
    $black = @ImageColorClosestHWB($img, 0, 0, 0);
    $grey = @ImageColorClosestHWB($img, 160, 160, 160);
    $white = @ImageColorClosestHWB($img, 255, 255, 255);

    // modifies the image
    if(!$q = @mysql_query("SELECT ${dbprefix}_Baloons.IDBaloon, ${dbprefix}_Baloons.Shape, ${dbprefix}_Texts.CenterX, ${dbprefix}_Texts.CenterY, ${dbprefix}_Texts.Testo FROM (${dbprefix}_Baloons LEFT JOIN ${dbprefix}_Texts ON ${dbprefix}_Baloons.IDBaloon = ${dbprefix}_Texts.IDBaloon) WHERE ${dbprefix}_Baloons.IDStrip = $id AND ${dbprefix}_Texts.IDLanguage = '$lang'")) return FALSE;

    /*$style = GetStyle($style_default);
    $bb = @ImageTTFBBox($style['size'], 0, $style['font'], "X");
    $size_y = ($bb[1] - $bb[5]) * 1.5;
    print_r($style);
    echo "Size_Y $size_y\n";
    $topline = $bb['top'];*/
    
    while($row = @mysql_fetch_row($q)) {
	$idf = (int)$row[0];
	$forma = explode(',', (string)$row[1]);
	$centrox = (int)$row[2];
	$centroy = (int)$row[3];
	$testo = explode("\r\n", (string)$row[4]);

	// blanks the baloon
	if($forma[0] == 'e') { // ellisse
	    @ImageFilledEllipse($img, $forma[1], $forma[2], $forma[3], $forma[4], $white);
	    if($debug) @ImageEllipse($img, $forma[1], $forma[2], $forma[3], $forma[4], $grey);
	} elseif($forma[0] == 'r') { // rettangolo
	    @ImageFilledRectangle($img, $forma[1], $forma[2], $forma[3], $forma[4], $white);
	    if($debug) @ImageRectangle($img, $forma[1], $forma[2], $forma[3], $forma[4], $grey);
	} elseif($forma[0] == 'p') { // poligono
	    $pts = array_slice($forma, 1);
	    @ImageFilledPolygon($img, $pts, sizeof($pts)/2, $white);
	    if($debug) @ImagePolygon($img, $pts, sizeof($pts)/2, $grey);
	}

	if($debug) {
	    @ImageLine($img, $centrox - 10, $centroy - 10, $centrox + 10, $centroy + 10, $grey);
	    @ImageLine($img, $centrox + 10, $centroy - 10, $centrox - 10, $centroy + 10, $grey);
	}

	// fills in the new text

	$style = $style_default;
	$align = $align_default;
	$testo_style = array();
	$size_y = 0;
	foreach($testo as $line) { // calculates the total height
	    $line_style = StyleSplit($line, $style, $align);
	    $record = array();
	    $record['line'] = $line_style;
	    $record['bbox'] = MyImageTTFBBox($line_style);
	    array_push($testo_style, $record);
	    $size_y += $record['bbox']['height'];
	}
	$pos_y = $centroy - ($size_y / 2);
	foreach($testo_style as $line) {
	    //echo "Line="; print_r($line);
	    switch($align) {
	    case 'left':
		$pos_x = $centrox;
		break;
	    case 'center':
		$pos_x = $centrox - ($line['bbox']['width'] / 2);
		break;
	    case 'right':
		$pos_x = $centrox - $line['bbox']['width'];
		break;
	    default:
		die("unexpected alignment: [$line[align]]");
	    }
	    $pos_y += $line['bbox']['height'];
	    if($debug) @ImageRectangle($img, $pos_x + $line['bbox']['left'], $pos_y + $line['bbox']['top'], $pos_x + $line['bbox']['right'], $pos_y + $line['bbox']['bottom'], $grey);
	    //if($debug) echo "Text in ($pos_x, $pos_y) with style $style ($style_data[font] $style_data[size])\n";
	    foreach($line['line'] as $piece) {
		$style_data = GetStyle($piece['style']);
		@ImageTTFText($img, $style_data['size'], 0, $pos_x, $pos_y, $black, $style_data['font'], $piece['text']);
		//echo "Width="; print_r($piece);
		$pos_x += $piece['bbox']['width'];
	    }
	}
    }
    @mysql_free_result($q);

    // streams out the resulting image
    @ImagePNG($img, $dest);

    // clears the buffers
    @ImageDestroy($img);

    return TRUE;
}

function GetStrip($id, $lang = 'en') {
    global $dbprefix;
    $u = array();
    $u['id'] = (int)$id;
    $u['lang'] = $lang;
    $u['filename'] = 'strips/' . substr('0000' . $id, -4) . '-' . $lang;
    if(!$q = @mysql_query("SELECT URL, DimX, DimY FROM ${dbprefix}_Strips WHERE IDStrip = $u[id]")) return FALSE;
    if(!$row = @mysql_fetch_array($q)) return FALSE;
    $url = (string)$row['URL'];
    $u['width'] = (int)$row['DimX'];
    $u['height'] = (int)$row['DimY'];
    if($u['lang'] == 'en') {
	$ver = $row[1]; //TODO controllare questa data
	if(!@preg_match('/\.(gif|jpe?g|png)$/i', $url, $m)) return FALSE;
	$u['filename'] .=  '.' . strtolower($m[1]);
	if(!@file_exists($u['filename'])) {
	    if(!@copy($url, $u['filename'])) return FALSE;
	    @ClearStatCache();
	}
    } else {
	@mysql_free_result($q);
	if(!$q = @mysql_query("SELECT Versione FROM ${dbprefix}_Titles WHERE IDLanguage = '$u[lang]' AND IDStrip = $u[id]")) return FALSE;
	if(!$row = @mysql_fetch_array($q)) return FALSE;
	$u['filename'] .= '.png';
	if(@file_exists($u['filename']) && ($row['Versione'] > @date('Y-m-d H:i:s', @filemtime($u['filename']))))
	    @unlink($u['filename']);
	if(!@file_exists($u['filename'])) {
	    if(!@SubtitleStrip($u['id'], $u['lang'], $u['filename'])) return FALSE;
	    @ClearStatCache();
	}
    }
    @mysql_free_result($q);
    if(($u['width'] == 0 ) || ($u['height'] == 0 )) {
	// notice: this means that all the languages *must* have the same size
	$real_dim = getimagesize($u['filename']);
	$u['width'] = (int)$real_dim[0];
	$u['height'] = (int)$real_dim[1];
	@mysql_query("UPDATE ${dbprefix}_Strips SET DimX = $u[width], DimY = $u[height] WHERE IDStrip = $u[id]");
    }       
    return $u;
}
                             
function GetStripTitle($id, $lang = 'en') {
    global $dbprefix;
    if(!$q = @mysql_query("SELECT Testo FROM ${dbprefix}_Titles WHERE IDLanguage = '$lang' AND IDStrip = $id")) return FALSE;
    if(!$row = @mysql_fetch_array($q)) return FALSE;
    $u = (string)$row['Testo'];
    @mysql_free_result($q);
    return $u;
}
?>
